// actually output sparse .pj
BOOL Machine_CleanSave(void) {
	char Directory[255], FileName[255], ZipFile[255], String[100];
	char drive[_MAX_DRIVE] ,dir[_MAX_DIR], ext[_MAX_EXT];
	DWORD dwWritten, Value, c, d, c2;
	BYTE buf[4],*chunk;
	HANDLE hSaveFile,hOutFile;
	DWORD len,start;

	chunk=malloc(0x100000); //(BYTE *)VirtualAlloc(NULL,RdramSize,MEM_RESERVE|MEM_COMMIT,PAGE_READWRITE);
	if (!chunk) {
		DisplayError("couldn't allocate memory for clean save state creation");
		return TRUE;
	}

	//outpj=fopen("d:\\sparse.ram","w");
	//if (!outpj) {
	// DisplayError("failed to open output file");
	//}

	if (strlen(SaveAsFileName) == 0) {
		GetInstantSaveDir(Directory);
		sprintf(FileName,"%s%s",Directory,CurrentSave);
	} else {
		sprintf(FileName,"%s.pj",SaveAsFileName);
	}

	{
		hSaveFile = CreateFile(FileName,GENERIC_WRITE | GENERIC_READ, FILE_SHARE_READ,NULL,OPEN_EXISTING,
			FILE_ATTRIBUTE_NORMAL | FILE_FLAG_RANDOM_ACCESS, NULL);

		hOutFile = CreateFile("d:\\sparse.ram",GENERIC_WRITE | GENERIC_READ, FILE_SHARE_READ,NULL,OPEN_ALWAYS,
			FILE_ATTRIBUTE_NORMAL | FILE_FLAG_RANDOM_ACCESS, NULL);

		if (hSaveFile == INVALID_HANDLE_VALUE) {
			switch (GetLastError()) {
			case ERROR_PATH_NOT_FOUND:
				CreateDirectory(Directory,NULL);
				hSaveFile = CreateFile(FileName,GENERIC_WRITE | GENERIC_READ, FILE_SHARE_READ,
					NULL,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL | FILE_FLAG_RANDOM_ACCESS, NULL);
				if (hSaveFile == INVALID_HANDLE_VALUE) {
					DisplayError("Failed to open Save File");
					return TRUE;
				}
				break;
			default:
				DisplayError("Failed to open Save File");
				return TRUE;
			}
		}
		if (hOutFile == INVALID_HANDLE_VALUE) {
			DisplayError("Failed to open new sparse savestate");
			return TRUE;
		}

		// Write sparse header
		//fwrite("SR64",4,1,outpj);
		WriteFile(hOutFile,"SR64",4,&dwWritten,0);

		// Include complete header as one chunk
		len=0x75c;
		start=0;
		//fwrite(&len,4,1,outpj);
		//fwrite(&start,4,1,outpj);
		WriteFile(hOutFile,&len,4,&dwWritten,0);
		WriteFile(hOutFile,&start,4,&dwWritten,0);

		SetFilePointer(hSaveFile,0,NULL,FILE_BEGIN);
		for (c=0; c < 0x75c/4; c++) {
			ReadFile(hSaveFile,buf,4,&dwWritten,0);
			//fwrite(buf,1,4,outpj) != 4) DisplayError("eh?");
			WriteFile(hOutFile,buf,4,&dwWritten,0);
		}

		//CloseHandle(hOutFile);
		//CloseHandle(hSaveFile);
		//return TRUE;

		//DisplayError("here I be");

		// Write main section sparsely

		SetFilePointer(hSaveFile,0x75c,NULL,FILE_BEGIN);
		len=0;
		for (c=0; c < 0x800000; c+=0x10000) {
			for (d=0; d < 0x10000; d+=4) {
				for (c2=(c+d<PARANOIA)?0:(c+d-PARANOIA); c2 < c+d+PARANOIA; c2++) {
					if (logdata[c2]&4) break;
				}
				if (c2<(c+d+PARANOIA)) {// needed
					if (!len) start=c+d+0x75c;
					SetFilePointer(hSaveFile,c+d+0x75c,NULL,FILE_BEGIN);
					ReadFile(hSaveFile,chunk+len,4,&dwWritten,0);
					len+=4;
				} else { // not needed
					if (len) {
						// output chunk
						//WriteChunk(len,start,chunk,outpj);
						//fwrite(&len,4,1,outpj);
						//fwrite(&start,4,1,outpj);
						WriteFile(hOutFile,&len,4,&dwWritten,0);
						WriteFile(hOutFile,&start,4,&dwWritten,0);
						
						for (c2=0; c2 < len; c2+=4) {
							//fwrite(chunk+c2,4,1,outpj);
							WriteFile(hOutFile,chunk+c2,4,&dwWritten,0);
						}
						len=0;
					}
				}
			}
			sprintf(String,"Saved: %08x",c);
			SendMessage(hStatusWnd,SB_SETTEXT,0,(LPARAM)String);
		}
		if (len) {
			WriteFile(hOutFile,&len,4,&dwWritten,0);
			WriteFile(hOutFile,&start,4,&dwWritten,0);
			
			for (c2=0; c2 < len; c2+=4) {
				//fwrite(chunk+c2,4,1,outpj);
				WriteFile(hOutFile,chunk+c2,4,&dwWritten,0);
			}
			len=0;
		}

		// Include rest of file as one chunk
		len=0x2000;
		start=0x75c+RdramSize;
		//fwrite(&len,4,1,outpj);
		//fwrite(&start,4,1,outpj);
		WriteFile(hOutFile,&len,4,&dwWritten,0);
		WriteFile(hOutFile,&start,4,&dwWritten,0);
		SetFilePointer(hSaveFile,0x75c+RdramSize,NULL,FILE_BEGIN);
		for (c=0; c < 0x2000/4; c++) {
			ReadFile(hSaveFile,buf,4,&dwWritten,0);
			//fwrite(buf,4,1,outpj);
			WriteFile(hOutFile,buf,4,&dwWritten,0);
		}

		// closing zero length
		len=0;
		//fwrite(buf,4,1,outpj);
		WriteFile(hOutFile,&len,4,&dwWritten,0);

		CloseHandle(hOutFile);
		CloseHandle(hSaveFile);
	}

	//VirtualFree( chunk, 0 , MEM_RELEASE);
	free(chunk);
	strcpy(SaveAsFileName,"");
	strcpy(LoadFileName,"");
	sprintf(String,"Clean-Saved current state to d:\\sparse.ram");
	SendMessage( hStatusWnd, SB_SETTEXT, 0, (LPARAM)String );
	return TRUE;
}